class Librarix::Models::Genre < Sequel::Model
  def self.fetch
    unrestrict_primary_key

    genres = Tmdb::Genre.list['genres']
    genres.each do |genre|
      find_or_create(id: genre['id']) { |g| g.name = genre['name'] }
    end

    genres
  end

  many_to_many :movies
  plugin :association_dependencies, movies: :nullify
end
