class Librarix::Models::Movie < Sequel::Model
  def self.fetch(id)
    unrestrict_primary_key

    movie = find(id: id) || new(id: id)
    movie.fetch!
  end

  plugin :serialization
  serialize_attributes :json, :data

  many_to_many :genres
  plugin :association_dependencies, genres: :nullify

  def fetch!
    tmdb_data = Tmdb::Movie.detail(id)
    self.data = tmdb_data
    save

    genres_id = data['genres'].map { |g| g['id'] }
    Librarix::Models::Genre.where(id: genres_id).all.each do |genre|
      add_genre(genre) unless genres.include?(genre)
    end

    self
  end

  def download!
    self.downloaded = !downloaded
    save
  end

  def view!
    self.viewed = !viewed
    save
  end
end
